package countby

class BookController {

    def index() {
		
		// FYI: Author with username "a3" has 4 books, 2 of them scientific and 2 non-scientific
		// See Bootstrap.groovy
		
		// everything fine here
		def List listAll = Book.list()
		println ("All books .size(): " + listAll.size())
		
		def int countAll = Book.count()
		println ("All books .count(): " + countAll)
		
		def List listScientificWhere = Book.whereScientificOnly.list()
		println ("Scientific books (where) .size(): " + listScientificWhere.size())
		
		def List listScientificNamedQuery = Book.namedQueryScientificOnly.list()
		println ("Scientific books (named query) .size(): " + listScientificNamedQuery.size())
		
		def int countScientificWhere = Book.whereScientificOnly.count()
		println ("Scientific books (where) .count(): " + countScientificWhere)
		
		def int countScientificNamedQuery = Book.namedQueryScientificOnly.count()
		println ("Scientific books (named query) .count(): " + countScientificNamedQuery)
		println ("")
		
		// Dynamic count returns different sizes on where query and named query
		def List listAuthor3 = Book.findAllByAuthor(Author.findByUsername("a3"))
		println ("All books by author 3 .size(): " + listAuthor3.size()) // 4 books => OK
		
		def int countAuthor3 = Book.countByAuthor(Author.findByUsername("a3"))
		println ("All books by author 3 .count(): " + countAuthor3) // 4 books => OK
		
		def List listAuthor3ScientificWhere = Book.whereScientificOnly.findAllByAuthor(Author.findByUsername("a3"))
		println ("Scientific books by author 3 (where) .size()): " + listAuthor3ScientificWhere.size()) // 2 books => OK
		
		def List listAuthor3ScientificNamedQuery = Book.namedQueryScientificOnly.findAllByAuthor(Author.findByUsername("a3"))
		println ("Scientific books by author 3 (named query) .size()): " + listAuthor3ScientificNamedQuery.size()) // 2 books => OK
		
		def int countAuthor3ScientificWhere = Book.whereScientificOnly.countByAuthor(Author.findByUsername("a3"))
		println ("Scientific books by author 3 (where) dynamic count()): " + countAuthor3ScientificWhere) // 4 books => WRONG!
		
		def int countAuthor3ScientificNamedQuery = Book.namedQueryScientificOnly.countByAuthor(Author.findByUsername("a3"))
		println ("Scientific books by author 3 (named query) dynamic count()): " + countAuthor3ScientificNamedQuery) // 2 books => OK
		println ("")
		
		respond listAll 
	}
	
	def show(Book book) {

		respond book
	}
}
